"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import ansys.api.modelcenter.v0.element_messages_pb2
import ansys.api.modelcenter.v0.variable_value_messages_pb2
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class _WorkflowInstanceState:
    ValueType = typing.NewType('ValueType', builtins.int)
    V: typing_extensions.TypeAlias = ValueType
class _WorkflowInstanceStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_WorkflowInstanceState.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor = ...
    WORKFLOW_INSTANCE_STATE_UNSPECIFIED: WorkflowInstanceState.ValueType = ...  # 0
    """*
    The state is unspecified.
    """

    WORKFLOW_INSTANCE_STATE_INVALID: WorkflowInstanceState.ValueType = ...  # 1
    """*
    Some values in the workflow are not valid.
    The workflow can be run to attempt to produce valid values for those variables.
    """

    WORKFLOW_INSTANCE_STATE_RUNNING: WorkflowInstanceState.ValueType = ...  # 2
    """*
    The workflow is currently running.
    """

    WORKFLOW_INSTANCE_STATE_PAUSED: WorkflowInstanceState.ValueType = ...  # 3
    """*
    A workflow run was started and paused.
    """

    WORKFLOW_INSTANCE_STATE_FAILED: WorkflowInstanceState.ValueType = ...  # 4
    """*
    A workflow run failed.
    """

    WORKFLOW_INSTANCE_STATE_SUCCESS: WorkflowInstanceState.ValueType = ...  # 5
    """*
    A workflow run succeeded.
    """

class WorkflowInstanceState(_WorkflowInstanceState, metaclass=_WorkflowInstanceStateEnumTypeWrapper):
    """*
    The workflow's execution state.
    """
    pass

WORKFLOW_INSTANCE_STATE_UNSPECIFIED: WorkflowInstanceState.ValueType = ...  # 0
"""*
The state is unspecified.
"""

WORKFLOW_INSTANCE_STATE_INVALID: WorkflowInstanceState.ValueType = ...  # 1
"""*
Some values in the workflow are not valid.
The workflow can be run to attempt to produce valid values for those variables.
"""

WORKFLOW_INSTANCE_STATE_RUNNING: WorkflowInstanceState.ValueType = ...  # 2
"""*
The workflow is currently running.
"""

WORKFLOW_INSTANCE_STATE_PAUSED: WorkflowInstanceState.ValueType = ...  # 3
"""*
A workflow run was started and paused.
"""

WORKFLOW_INSTANCE_STATE_FAILED: WorkflowInstanceState.ValueType = ...  # 4
"""*
A workflow run failed.
"""

WORKFLOW_INSTANCE_STATE_SUCCESS: WorkflowInstanceState.ValueType = ...  # 5
"""*
A workflow run succeeded.
"""

global___WorkflowInstanceState = WorkflowInstanceState


class GetWorkflowStateRequest(google.protobuf.message.Message):
    """*
    A request to get the state of the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___GetWorkflowStateRequest = GetWorkflowStateRequest

class GetWorkflowStateResponse(google.protobuf.message.Message):
    """*
    A response indicating what the state of the workflow is.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    STATE_FIELD_NUMBER: builtins.int
    state: global___WorkflowInstanceState.ValueType = ...
    def __init__(self,
        *,
        state : global___WorkflowInstanceState.ValueType = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["state",b"state"]) -> None: ...
global___GetWorkflowStateResponse = GetWorkflowStateResponse

class WorkflowId(google.protobuf.message.Message):
    """*
    An identifier for an individual workflow instance.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ID_FIELD_NUMBER: builtins.int
    id: typing.Text = ...
    """*
    The identifying string for the workflow instance.
    """

    def __init__(self,
        *,
        id : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id",b"id"]) -> None: ...
global___WorkflowId = WorkflowId

class NamedElementWorkflow(google.protobuf.message.Message):
    """*
    An element ID combined with a name.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    WORKFLOW_FIELD_NUMBER: builtins.int
    ELEMENT_FULL_NAME_FIELD_NUMBER: builtins.int
    @property
    def workflow(self) -> global___WorkflowId:
        """*
        The workflow's ID.
        """
        pass
    @property
    def element_full_name(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementName:
        """*
        The name of the element.
        """
        pass
    def __init__(self,
        *,
        workflow : typing.Optional[global___WorkflowId] = ...,
        element_full_name : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementName] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["element_full_name",b"element_full_name","workflow",b"workflow"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["element_full_name",b"element_full_name","workflow",b"workflow"]) -> None: ...
global___NamedElementWorkflow = NamedElementWorkflow

class WorkflowRunRequest(google.protobuf.message.Message):
    """*
    A request to run a workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class InputsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: typing.Text = ...
        @property
        def value(self) -> ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableState: ...
        def __init__(self,
            *,
            key : typing.Text = ...,
            value : typing.Optional[ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableState] = ...,
            ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["value",b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["key",b"key","value",b"value"]) -> None: ...

    TARGET_FIELD_NUMBER: builtins.int
    INPUTS_FIELD_NUMBER: builtins.int
    RESET_FIELD_NUMBER: builtins.int
    VALIDATION_NAMES_FIELD_NUMBER: builtins.int
    COLLECTION_NAMES_FIELD_NUMBER: builtins.int
    @property
    def target(self) -> global___WorkflowId:
        """*
        The target workflow.
        """
        pass
    @property
    def inputs(self) -> google.protobuf.internal.containers.MessageMap[typing.Text, ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableState]:
        """*
        Input values to be set before the run.
        The keys in the map are variable names.
        """
        pass
    reset: builtins.bool = ...
    """*
    If true, reset the validity of all elements in the workflow before running.
    """

    @property
    def validation_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """*
        The workflow elements to validate.
        """
        pass
    @property
    def collection_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """*
        The names of the workflow elements to return when the run is complete.
        """
        pass
    def __init__(self,
        *,
        target : typing.Optional[global___WorkflowId] = ...,
        inputs : typing.Optional[typing.Mapping[typing.Text, ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableState]] = ...,
        reset : builtins.bool = ...,
        validation_names : typing.Optional[typing.Iterable[typing.Text]] = ...,
        collection_names : typing.Optional[typing.Iterable[typing.Text]] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target",b"target"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["collection_names",b"collection_names","inputs",b"inputs","reset",b"reset","target",b"target","validation_names",b"validation_names"]) -> None: ...
global___WorkflowRunRequest = WorkflowRunRequest

class WorkflowRunResponse(google.protobuf.message.Message):
    """*
    A response to a request to run a workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class ResultsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: typing.Text = ...
        @property
        def value(self) -> ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableState: ...
        def __init__(self,
            *,
            key : typing.Text = ...,
            value : typing.Optional[ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableState] = ...,
            ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["value",b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["key",b"key","value",b"value"]) -> None: ...

    RESULTS_FIELD_NUMBER: builtins.int
    @property
    def results(self) -> google.protobuf.internal.containers.MessageMap[typing.Text, ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableState]:
        """*
        The requested variables.
        """
        pass
    def __init__(self,
        *,
        results : typing.Optional[typing.Mapping[typing.Text, ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableState]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["results",b"results"]) -> None: ...
global___WorkflowRunResponse = WorkflowRunResponse

class WorkflowHaltRequest(google.protobuf.message.Message):
    """*
    A request to halt the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___WorkflowHaltRequest = WorkflowHaltRequest

class WorkflowHaltResponse(google.protobuf.message.Message):
    """*
    A response to a request to halt the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___WorkflowHaltResponse = WorkflowHaltResponse

class WorkflowStartRunResponse(google.protobuf.message.Message):
    """*
    A response to a request to run a workflow asynchronously.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___WorkflowStartRunResponse = WorkflowStartRunResponse

class WorkflowGetRootResponse(google.protobuf.message.Message):
    """*
    A response indicating the root element of a workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ID_FIELD_NUMBER: builtins.int
    @property
    def id(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The root element.
        """
        pass
    def __init__(self,
        *,
        id : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["id",b"id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["id",b"id"]) -> None: ...
global___WorkflowGetRootResponse = WorkflowGetRootResponse

class WorkflowGetDirectoryResponse(google.protobuf.message.Message):
    """*
    A response indicating the directory in which the workflow is stored.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    WORKFLOW_DIR_FIELD_NUMBER: builtins.int
    workflow_dir: typing.Text = ...
    """*
    The directory storing the workflow.
    """

    def __init__(self,
        *,
        workflow_dir : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["workflow_dir",b"workflow_dir"]) -> None: ...
global___WorkflowGetDirectoryResponse = WorkflowGetDirectoryResponse

class WorkflowCreateComponentRequest(google.protobuf.message.Message):
    """*
    A request to create a component within a workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SOURCE_PATH_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    PARENT_FIELD_NUMBER: builtins.int
    INIT_STR_FIELD_NUMBER: builtins.int
    COORDS_FIELD_NUMBER: builtins.int
    AFTER_COMP_FIELD_NUMBER: builtins.int
    source_path: typing.Text = ...
    """*
    The source of the component.
    """

    name: typing.Text = ...
    """*
    The component's short name.
    """

    @property
    def parent(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The parent element.
        """
        pass
    init_str: typing.Text = ...
    """*
    An optional string used by the component to initialize itself.
    """

    @property
    def coords(self) -> ansys.api.modelcenter.v0.element_messages_pb2.AnalysisViewPosition:
        """*
        Coordinates at which to place the new component.
        """
        pass
    @property
    def after_comp(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        A component after which the new component should be placed.
        """
        pass
    def __init__(self,
        *,
        source_path : typing.Text = ...,
        name : typing.Text = ...,
        parent : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        init_str : typing.Optional[typing.Text] = ...,
        coords : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.AnalysisViewPosition] = ...,
        after_comp : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["_init_str",b"_init_str","after_comp",b"after_comp","coords",b"coords","init_str",b"init_str","parent",b"parent","position",b"position"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["_init_str",b"_init_str","after_comp",b"after_comp","coords",b"coords","init_str",b"init_str","name",b"name","parent",b"parent","position",b"position","source_path",b"source_path"]) -> None: ...
    @typing.overload
    def WhichOneof(self, oneof_group: typing_extensions.Literal["_init_str",b"_init_str"]) -> typing.Optional[typing_extensions.Literal["init_str"]]: ...
    @typing.overload
    def WhichOneof(self, oneof_group: typing_extensions.Literal["position",b"position"]) -> typing.Optional[typing_extensions.Literal["coords","after_comp"]]: ...
global___WorkflowCreateComponentRequest = WorkflowCreateComponentRequest

class WorkflowCreateComponentResponse(google.protobuf.message.Message):
    """*
    A response to a request to create a component.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    CREATED_FIELD_NUMBER: builtins.int
    @property
    def created(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The ID for the newly created component.
        """
        pass
    def __init__(self,
        *,
        created : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["created",b"created"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["created",b"created"]) -> None: ...
global___WorkflowCreateComponentResponse = WorkflowCreateComponentResponse

class WorkflowCreateLinkRequest(google.protobuf.message.Message):
    """*
    A request to create a link in the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_FIELD_NUMBER: builtins.int
    EQUATION_FIELD_NUMBER: builtins.int
    @property
    def target(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The target element.
        """
        pass
    equation: typing.Text = ...
    """*
    The expression that will drive the value of the target element
    """

    def __init__(self,
        *,
        target : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        equation : typing.Text = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target",b"target"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["equation",b"equation","target",b"target"]) -> None: ...
global___WorkflowCreateLinkRequest = WorkflowCreateLinkRequest

class WorkflowCreateLinkResponse(google.protobuf.message.Message):
    """*
    A response to a request to create a link in the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___WorkflowCreateLinkResponse = WorkflowCreateLinkResponse

class WorkflowSaveResponse(google.protobuf.message.Message):
    """*
    A response to a request to save the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___WorkflowSaveResponse = WorkflowSaveResponse

class WorkflowSaveAsRequest(google.protobuf.message.Message):
    """*
    A request to save the workflow to a new location.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_FIELD_NUMBER: builtins.int
    NEW_TARGET_PATH_FIELD_NUMBER: builtins.int
    @property
    def target(self) -> global___WorkflowId:
        """*
        The target of the request.
        """
        pass
    new_target_path: typing.Text = ...
    """*
    The new path for saving the workflow.
    """

    def __init__(self,
        *,
        target : typing.Optional[global___WorkflowId] = ...,
        new_target_path : typing.Text = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target",b"target"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["new_target_path",b"new_target_path","target",b"target"]) -> None: ...
global___WorkflowSaveAsRequest = WorkflowSaveAsRequest

class WorkflowCloseResponse(google.protobuf.message.Message):
    """*
    A response to a request to close the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___WorkflowCloseResponse = WorkflowCloseResponse

class WorkflowRemoveComponentRequest(google.protobuf.message.Message):
    """*
    A request to remove a component from the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_FIELD_NUMBER: builtins.int
    @property
    def target(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The target element.
        """
        pass
    def __init__(self,
        *,
        target : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target",b"target"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["target",b"target"]) -> None: ...
global___WorkflowRemoveComponentRequest = WorkflowRemoveComponentRequest

class WorkflowRemoveComponentResponse(google.protobuf.message.Message):
    """*
    A response to a request to remove the component from the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    EXISTED_FIELD_NUMBER: builtins.int
    existed: builtins.bool = ...
    """*
    True if the component existed.
    """

    def __init__(self,
        *,
        existed : builtins.bool = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["existed",b"existed"]) -> None: ...
global___WorkflowRemoveComponentResponse = WorkflowRemoveComponentResponse

class WorkflowBreakLinkRequest(google.protobuf.message.Message):
    """TODO: This should be renamed to something more like "DatapinLinkIdentifier".

    *
    A request to break a link within the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_VAR_FIELD_NUMBER: builtins.int
    @property
    def target_var(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The variable that is the "target"
        end of the link to break.
        """
        pass
    def __init__(self,
        *,
        target_var : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target_var",b"target_var"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["target_var",b"target_var"]) -> None: ...
global___WorkflowBreakLinkRequest = WorkflowBreakLinkRequest

class WorkflowSuspendOrResumeLinkRequest(google.protobuf.message.Message):
    """*
    A request to suspend or resume a link.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_LINK_LHS_FIELD_NUMBER: builtins.int
    SUSPEND_FIELD_NUMBER: builtins.int
    @property
    def target_link_lhs(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The variable that is the lef-hand side (target) of the link.
        """
        pass
    suspend: builtins.bool = ...
    """*
    True to suspend the link, false to resume it.
    """

    def __init__(self,
        *,
        target_link_lhs : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        suspend : builtins.bool = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target_link_lhs",b"target_link_lhs"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["suspend",b"suspend","target_link_lhs",b"target_link_lhs"]) -> None: ...
global___WorkflowSuspendOrResumeLinkRequest = WorkflowSuspendOrResumeLinkRequest

class WorkflowLinkSuspension(google.protobuf.message.Message):
    """*
    A message indicating the suspension state of a link, either currently
    or just before it was changed.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    IS_SUSPENDED_FIELD_NUMBER: builtins.int
    is_suspended: builtins.bool = ...
    """*
    True if the link is (or was) suspended,
    false if it is active.
    """

    def __init__(self,
        *,
        is_suspended : builtins.bool = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["is_suspended",b"is_suspended"]) -> None: ...
global___WorkflowLinkSuspension = WorkflowLinkSuspension

class WorkflowBreakLinkResponse(google.protobuf.message.Message):
    """*
    A response to a request to break a link.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    EXISTED_FIELD_NUMBER: builtins.int
    existed: builtins.bool = ...
    """*
    True if a link existed to the specified variable.
    """

    def __init__(self,
        *,
        existed : builtins.bool = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["existed",b"existed"]) -> None: ...
global___WorkflowBreakLinkResponse = WorkflowBreakLinkResponse

class WorkflowLinkInfo(google.protobuf.message.Message):
    """*
    A message containing information about a link.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    LHS_FIELD_NUMBER: builtins.int
    RHS_FIELD_NUMBER: builtins.int
    @property
    def lhs(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The target of the link.
        """
        pass
    rhs: typing.Text = ...
    """*
    The expression that drives the value of the left-hand side of the link.
    """

    def __init__(self,
        *,
        lhs : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        rhs : typing.Text = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["lhs",b"lhs"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["lhs",b"lhs","rhs",b"rhs"]) -> None: ...
global___WorkflowLinkInfo = WorkflowLinkInfo

class WorkflowAutoLinkRequest(google.protobuf.message.Message):
    """*
    A request to automatically link two components.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SOURCE_COMP_FIELD_NUMBER: builtins.int
    TARGET_COMP_FIELD_NUMBER: builtins.int
    @property
    def source_comp(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The source component.
        """
        pass
    @property
    def target_comp(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The target component.
        """
        pass
    def __init__(self,
        *,
        source_comp : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        target_comp : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["source_comp",b"source_comp","target_comp",b"target_comp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["source_comp",b"source_comp","target_comp",b"target_comp"]) -> None: ...
global___WorkflowAutoLinkRequest = WorkflowAutoLinkRequest

class WorkflowAutoLinkResponse(google.protobuf.message.Message):
    """*
    A response to a request to auto-link two components.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    CREATED_LINKS_FIELD_NUMBER: builtins.int
    @property
    def created_links(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___WorkflowLinkInfo]:
        """*
        The links created by the auto-link process.
        """
        pass
    def __init__(self,
        *,
        created_links : typing.Optional[typing.Iterable[global___WorkflowLinkInfo]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["created_links",b"created_links"]) -> None: ...
global___WorkflowAutoLinkResponse = WorkflowAutoLinkResponse

class WorkflowGetLinksResponse(google.protobuf.message.Message):
    """*
    A response to a request for the links in the workflow.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    LINKS_FIELD_NUMBER: builtins.int
    @property
    def links(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___WorkflowLinkInfo]:
        """*
        The links in the workflow.
        """
        pass
    def __init__(self,
        *,
        links : typing.Optional[typing.Iterable[global___WorkflowLinkInfo]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["links",b"links"]) -> None: ...
global___WorkflowGetLinksResponse = WorkflowGetLinksResponse

class ElementInfo(google.protobuf.message.Message):
    """*
    Information on an element.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ID_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    VAR_TYPE_FIELD_NUMBER: builtins.int
    @property
    def id(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """
        The ID of the element.
        """
        pass
    type: ansys.api.modelcenter.v0.element_messages_pb2.ElementType.ValueType = ...
    """
    The type of the element.
    """

    var_type: ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableType.ValueType = ...
    """
    If the element is a variable, it's variable type.
    """

    def __init__(self,
        *,
        id : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        type : ansys.api.modelcenter.v0.element_messages_pb2.ElementType.ValueType = ...,
        var_type : typing.Optional[ansys.api.modelcenter.v0.variable_value_messages_pb2.VariableType.ValueType] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["_var_type",b"_var_type","id",b"id","var_type",b"var_type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["_var_type",b"_var_type","id",b"id","type",b"type","var_type",b"var_type"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["_var_type",b"_var_type"]) -> typing.Optional[typing_extensions.Literal["var_type"]]: ...
global___ElementInfo = ElementInfo

class ElementInfoCollection(google.protobuf.message.Message):
    """*
    Information about a collection of elements.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    ELEMENTS_FIELD_NUMBER: builtins.int
    @property
    def elements(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ElementInfo]: ...
    def __init__(self,
        *,
        elements : typing.Optional[typing.Iterable[global___ElementInfo]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["elements",b"elements"]) -> None: ...
global___ElementInfoCollection = ElementInfoCollection

class ElementIdOrName(google.protobuf.message.Message):
    """
    Represents either an ElementName or ElementId, for calls that can handle both.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_ID_FIELD_NUMBER: builtins.int
    TARGET_NAME_FIELD_NUMBER: builtins.int
    @property
    def target_id(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId: ...
    @property
    def target_name(self) -> global___NamedElementWorkflow: ...
    def __init__(self,
        *,
        target_id : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        target_name : typing.Optional[global___NamedElementWorkflow] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target",b"target","target_id",b"target_id","target_name",b"target_name"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["target",b"target","target_id",b"target_id","target_name",b"target_name"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["target",b"target"]) -> typing.Optional[typing_extensions.Literal["target_id","target_name"]]: ...
global___ElementIdOrName = ElementIdOrName

class DeleteAssemblyVariableRequest(google.protobuf.message.Message):
    """*
    Represents a request to delete an assembly variable.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_FIELD_NUMBER: builtins.int
    @property
    def target(self) -> global___ElementIdOrName: ...
    def __init__(self,
        *,
        target : typing.Optional[global___ElementIdOrName] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target",b"target"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["target",b"target"]) -> None: ...
global___DeleteAssemblyVariableRequest = DeleteAssemblyVariableRequest

class MoveComponentRequest(google.protobuf.message.Message):
    """*
    Represents a request to move a component.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_FIELD_NUMBER: builtins.int
    NEW_PARENT_FIELD_NUMBER: builtins.int
    INDEX_PARENT_FIELD_NUMBER: builtins.int
    @property
    def target(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The component to move.
        """
        pass
    @property
    def new_parent(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The new parent for the component. This should be an assembly.
        """
        pass
    index_parent: builtins.int = ...
    """*
    The new index in the parent. Pass -1 to add the component at the end.
    If the index is larger than the number of components in the element,
    it will be placed at the end.
    """

    def __init__(self,
        *,
        target : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        new_parent : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        index_parent : builtins.int = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["new_parent",b"new_parent","target",b"target"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["index_parent",b"index_parent","new_parent",b"new_parent","target",b"target"]) -> None: ...
global___MoveComponentRequest = MoveComponentRequest

class SetReferenceArrayLengthRequest(google.protobuf.message.Message):
    """*
    Represents a request to resize a reference array.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TARGET_FIELD_NUMBER: builtins.int
    NEW_SIZE_FIELD_NUMBER: builtins.int
    @property
    def target(self) -> ansys.api.modelcenter.v0.element_messages_pb2.ElementId:
        """*
        The reference array to modify.
        """
        pass
    new_size: builtins.int = ...
    """*
    The new size of the array.
    """

    def __init__(self,
        *,
        target : typing.Optional[ansys.api.modelcenter.v0.element_messages_pb2.ElementId] = ...,
        new_size : builtins.int = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["target",b"target"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["new_size",b"new_size","target",b"target"]) -> None: ...
global___SetReferenceArrayLengthRequest = SetReferenceArrayLengthRequest

class SetReferenceArrayLengthResponse(google.protobuf.message.Message):
    """*
    Represents a response to a request to resize a reference array.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___SetReferenceArrayLengthResponse = SetReferenceArrayLengthResponse
